#ifndef MOTIFEDITORDELEGATE_HPP_
#define MOTIFEDITORDELEGATE_HPP_

#include <QItemDelegate>
#include <QWidget>

#include "qui/motif_editor/MotifModel.hpp"

class MotifEditorDelegate : public QItemDelegate
{
  Q_OBJECT
  
public:
  MotifEditorDelegate(QWidget *parent=0);

  //! construct a editor widget for a given index.
  QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                        const QModelIndex &index) const;
                        
  virtual bool editorEvent(QEvent *event, QAbstractItemModel *model, 
                           const QStyleOptionViewItem & option, const QModelIndex & index ); 

  void setEditorData(QWidget *editor, const QModelIndex &index) const;
  void setModelData(QWidget *editor, QAbstractItemModel *model,
                    const QModelIndex &index) const;

  void updateEditorGeometry(QWidget *editor,
      const QStyleOptionViewItem &option, const QModelIndex &index) const;
      
  virtual void paint ( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;    
private:
};

#endif /*MOTIFEDITORDELEGATE_HPP_*/
